/***********************************************************************/
/*                                                                     */    
/*  File : ChatApplet.java                                             */
/*  Author : WEI-NING LIN                                              */   
/*  Author : Isao yanagimachi                                */
/*                                                                     */
/*  Description:                                                       */
/*                                                                     */
/*    The  following module takes the user input, encrypts it using */
/*    other clients'  public key and pass them to the server.          */
/*    User is  required to select two prime numbers when logining in  */
/*    The public key is broadcasted via server to other clients and  */
/*    secret key  is kept AS PRIVATE                  */
/***********************************************************************/

import java.applet.Applet;
import java.awt.event.ActionListener;
import java.awt.event.ActionEvent;
import java.awt.event.*;
import java.io.Serializable;
import java.net.URL;
import java.util.*;
import java.awt.*;
import java.awt.event.ItemEvent;
import java.rmi.*;
import java.rmi.server.*;
import java.lang.Object;
import java.awt.*;

class DrawCanvas extends Canvas implements ActionListener
{
        
      private int last_x = 0;
      private int last_y = 0;
      private Vector plist = new Vector(10);
      private RSA rsa = new RSA();
      private List userList;
      private Point pubKeyList[] ;
      
      ChatServerInterface chatsvr;

      public DrawCanvas( )
      {
      }
      public void actionPerformed(ActionEvent event)
      {
 
        String arg = event.getSource().toString();
        RSA rsa = new RSA();
 
        System.out.println(arg);
        //login button
        if ( arg.indexOf("button0") != -1)
        {
        }
      }
      public void setUserList(  List _userList ){
         userList  = _userList;
      }
      public void setKeyList(  Point _pubKeyList[] ) {
         pubKeyList = _pubKeyList;
      }
      public void setServer(ChatServerInterface   cvi)
      {
          chatsvr = cvi;
      
      }
      public void clear()
      {
          plist.setSize(0);
          repaint();

      }
      public void paint(Graphics g)
      {
          if (     plist.size() > 0  )
          {
         
            Enumeration e = plist.elements();
           // Point lastp = (Point)e.nextElement();
            while (e.hasMoreElements())
            {
                Point currp = (Point) e.nextElement();
                g.fillOval(currp.x,currp.y,10,10);
                
              //  lastp.x = currp.x;
               // lastp.y = currp.y;
               
            }
          } 
      }
      
      public void _mouseDown(int _x, int _y)
      {
         plist.addElement(new Point(_x,_y) );  
         Graphics g = getGraphics();
         g.fillOval(_x,_y,10,10);
         //last_x = _x; 
         //last_y = _y;
         
         
      }
      
      public void _mouseDrag(int _x, int _y)
      {
            Graphics g = getGraphics();
            plist.addElement(new Point(_x,_y) );
            g.fillOval(_x,_y,10,10);
            //last_x = _x;
            //last_y = _y;
            
      
      }
      public boolean mouseDown(Event e, int _x, int _y)
      {
            long x;
            long y;
 
            try
            {
                int i=0; 
                while (i < userList.getItemCount() )
                {
                   String ruser = (String) userList.getItem(i);
                   Point pubkey = (Point) pubKeyList[i] ;
                  
                   x = rsa.encript((long)_x, pubkey.x, pubkey.y);
                   y = rsa.encript((long)_y, pubkey.x, pubkey.y);
                   chatsvr.mouseDown(ruser, x,y);
                   i++;
                }
            }
            catch (Exception evt)
            {
                evt.printStackTrace();
            }
            return true;
      }

      public boolean mouseDrag(Event e, int _x, int _y)
      {
            long x;
            long y;
 
            try
            {
                int i=0; 
                while (i < userList.getItemCount() )
                {
                   String ruser = (String) userList.getItem(i);
                   Point pubkey = (Point) pubKeyList[i] ;
                  
                   x = rsa.encript((long)_x, pubkey.x, pubkey.y);
                   y = rsa.encript((long)_y, pubkey.x, pubkey.y);
                   chatsvr.mouseDrag(ruser, x,y);
                   i++;
                }
            }
            catch (Exception evt)
            {
                evt.printStackTrace();
            }
            return true;
        /*
        System.out.println("d");
            try {
               chatsvr.mouseDrag(x,y); 
              }
              catch ( Exception ext) { ext.printStackTrace();}
            return true;
        */
      }
}
public class ChatApplet extends Applet implements ChatAppletInterface,
    ActionListener, Serializable ,ItemListener
{
    ChatServerInterface chatServer;

    Label label;
    Label label2;
    TextField inputField;
    Choice pChoice;
    Choice qChoice;

    Button bt1;
    Button bt2;
    Button bt3;
    TextArea outputArea;
    List userList;
    Point pubKeyList[];

    String user = "";
    boolean firsttime = false;

    //RSA keys 
    private long D;
    private long E;
    private long N;
    private long p;
    private long q;

    private DrawCanvas cv;
    //init function 
    public void init()
    {
        // create label
        label = new Label(" Please enter your name:");
        label.setBackground(Color.white);
        label.setForeground(Color.black);

        label2 = new Label("Select the primes:");
        label2.setBackground(Color.white);
        label2.setForeground(Color.black);

        // create input field
        inputField = new TextField();
        inputField.addActionListener(this);
        inputField.setBackground(Color.white);

   
        bt1 = new Button("Login");      
        bt1.addActionListener(this);
        bt2 = new Button("Log off");      
        bt2.addActionListener(this);
        bt3 = new Button("Clear");      
        bt3.addActionListener(this);
        pChoice = new Choice();
        qChoice = new Choice();
        pChoice.addItemListener(this);
        qChoice.addItemListener(this);
        p=35593; q = 17;

        pChoice.add("7");
        pChoice.add("13");
        pChoice.add("313");
        pChoice.add("1879");
        pChoice.add("5081");
        //pChoice.addActionListener(this);

        qChoice.add("29");
        qChoice.add("67");
        qChoice.add("347");
        qChoice.add("1303");
        qChoice.add("5507");
        //qChoice.addActionListener(this);

        // create panel for label and field and add them to it.
        Panel fieldPanel = new Panel();
        cv = new DrawCanvas();
        fieldPanel.setLayout(new GridLayout(4,2));
        fieldPanel.add(label);
        fieldPanel.add(inputField);
        fieldPanel.add(qChoice);
        fieldPanel.add(pChoice);
        fieldPanel.add(bt1);
        fieldPanel.add(bt2);
        fieldPanel.add(bt3);
        

        Panel dPanel = new Panel();
        
        //cv.addItemListener(this);
       
        dPanel.setLayout(new BorderLayout());
         dPanel.add("Center", cv );
        // create the output area
        outputArea = new TextArea("");
        outputArea.setEditable(false);

        // create the panel for the field panel and output area
        // and add them to it.
        Panel appletPanel = new Panel();
        appletPanel.setLayout(new BorderLayout());
        appletPanel.add("North", fieldPanel);
         
        appletPanel.add("Center", outputArea);
       
        // create the user list.
        userList = new List();

        // add the applet panel and userlist to the applet
        this.setLayout(new BorderLayout());
        this.add("Center", dPanel);
        this.add( "East",userList);
        this.add( "West",appletPanel);

        // set applet colors.
        setBackground(Color.white);
        setForeground(Color.black);

        // show the components
        fieldPanel.setVisible(true);
        appletPanel.setVisible(true);
        dPanel.setVisible(true);
        setVisible(true);
    }

    
    // for choice control
    public void itemStateChanged(ItemEvent evt)
    {
       if ( evt.toString().indexOf("choice1") != -1 && 
            evt.getStateChange() == ItemEvent.SELECTED )
       {
          p = Long.parseLong((String) evt.getItem()); 

       }
       if ( evt.toString().indexOf("choice0") != -1 && 
            evt.getStateChange() == ItemEvent.SELECTED )
       {
          q = Long.parseLong((String) evt.getItem()); 
       }


    }

    //applete starts, called after init
    public void start()
    {
        firsttime = true;

        outputArea.setText(""); // clear the text area.
        outputArea.append("Connecting to server ...   ");
        
        try
        {
            // System.out.println(getParameter("registryPort"));
            // System.out.println( getParameter("serverName"));
            // export the applet as a remote object.
            UnicastRemoteObject.exportObject(this);

            // lookup the Chat Server.
            URL base = getDocumentBase();
            String serverName =      
                                "//osprey7.npac.syr.edu"
                                + ":"
            + getParameter("registryPort") + "/"
            + getParameter("serverName");

           
            // get server as remote object.
            chatServer = (ChatServerInterface) Naming.lookup(serverName);
            cv.setServer(chatServer);
        }
        catch (Exception e)
        {
            outputArea.append("Error exporting applet: server may be down");
            return;
        }

        try
        {
            //updates this client's user list
            chatServer.connect(this);
        }
        catch (Exception e)
        {
            System.out.println("ChatApplet.start: an exception occurred: chatServer.connect");
            e.printStackTrace();
            return;
        }

        outputArea.append(" done.\n");

        //changes the label
        label.setText(" Please enter your name:");
        inputField.requestFocus();
    }

    //called when an applete is destroyed
    public void destroy()
    {
        try
        {
            chatServer.logoff(user);
        }
        catch (Exception e)
        {
          System.out.println("ChatApplet.actionPerformed: an exception occurred: chatServer.logoff");
          e.printStackTrace();
          return;
        }
    }
    //called when a user moves off the page
    public void stop()
    {
        try
        {
            chatServer.logoff(user);
        }
        catch (Exception e)
        {
          System.out.println("ChatApplet.actionPerformed: an exception occurred: chatServer.logoff");
          e.printStackTrace();
          return;
        }
    }

    public void mouseDown(long x, long y) throws RemoteException
    {
       RSA rsa = new RSA();
       x = rsa.descript(x,D,N);
       y = rsa.descript(y,D,N);
       System.out.println(x+" "+y);
       cv._mouseDown((int)x,(int)y);
        
    }
    public void mouseDrag(long x, long y) throws RemoteException
    {
       RSA rsa = new RSA();
       System.out.println("before decrypted : "+x+" "+y);
       x = rsa.descript(x,D,N);
       y = rsa.descript(y,D,N);
       System.out.println("after decrypted : "+x+" "+y);
       cv._mouseDrag((int)x,(int)y);
        
    }
   //displays the UNENCYPTED message
    public void displayMessage(String message)  throws RemoteException
    {
        if (outputArea == null)
            return;

        outputArea.append(message);

    }
    //displays the ENCYPTED message, called by server
    public void displayMessage(long emessage[]) throws RemoteException
    {
        if (outputArea == null)
            return;

        RSA rsa = new RSA();

        //descript
        String message = rsa.decryptMsg(emessage, D, N );
        outputArea.append(message + "\r\n");
    }

    //updates the user list and associated public key list, called by server
    public void updateUserList(Vector users, Vector keys) throws RemoteException
    {
        int i=0;
 
        userList.removeAll();
        if (!users.isEmpty())
        {
            Enumeration e = users.elements();
            Enumeration e1 = keys.elements();

            pubKeyList = new Point[users.size()];
            while (e.hasMoreElements())
            {
                String user = (String) e.nextElement();
                Point pubkey = (Point) e1.nextElement();
                userList.add(user);
                pubKeyList[i++] = pubkey  ;
            }
        }
       cv.setUserList(userList);
       cv.setKeyList(pubKeyList);
    }


    //encrypt the message before give it server
    public  long [] encrypt(String message)
    {
        RSA rsa = new RSA();
        return rsa.encryptMsg(new StringBuffer(message), E, N );
    }

    // to satisfy ActionListener interface
    public void actionPerformed(ActionEvent event)
    {

        String arg = event.getSource().toString();
        RSA rsa = new RSA();

        System.out.println(arg);
        //login button
        if ( arg.indexOf("button0") != -1)
        {
            user = inputField.getText();

            if (user.length() == 0)
                return;
            
            E = rsa.findE( p,q);
            N = p*q;
            D = rsa.extend( E, (p-1)*(q-1) );

            try
            {
                chatServer.login(this, user, new Point((int)E, (int)N) );
            }
            catch (Exception e)
            {
             System.out.println("ChatApplet.actionPerformed: an exception occurred: chatServer.login");
             e.printStackTrace();
             return;
            }
            
            label.setText(" Send a message:");
            qChoice.setVisible(false);   
            pChoice.setVisible(false);   
            bt1.setVisible(false);   
            inputField.setText("");
            firsttime = false;
        }

        //input text field, user message is entered here
        else if (arg.indexOf("textfield0") != -1 ) 
        {
            if ( firsttime ) return;
            String message = inputField.getText();

            if (message.length() == 0)
                return;

            //encrypt the message using every client's public keys
             // and let the server broadcast it to other clients
            try
            {
             int i=0; 
                while (i < userList.getItemCount() )
                {
                   String ruser = (String) userList.getItem(i);
                   Point pubkey = (Point) pubKeyList[i] ;
                   long emsg[] = rsa.encryptMsg(new StringBuffer(message),pubkey.x, pubkey.y);
                   chatServer.broadcastMessage(user, ruser, emsg);
               i++;
                }
            }
            catch (Exception e)
            {
             System.out.println("ChatApplet.actionPerformed: an exception occurred: chatServer.broadCastMessage");
             e.printStackTrace();
             return;
            }

            inputField.setText("");

            return;
        }
       //for log off button
        else if ( arg.indexOf("button1") != -1)
        {
            if ( !firsttime )
            {
               try
               {
                  
                   userList.removeAll();
                   cv.clear();
                  //removes my name from other clients' and the server's list
                  chatServer.logoff(user);
               }
               catch (Exception e)
               {
                System.out.println("ChatApplet.actionPerformed: an exception occurred: chatServer.logoff");
                e.printStackTrace();
                return;
               }
               firsttime  = true;
               qChoice.setVisible(true);   
               pChoice.setVisible(true);   
               bt1.setVisible(true);   
               label.setText(" Enter your name :");
           }
        }
        //clear button
        else
        {
                  cv.clear();
        }
    }
}

