import java.applet.*;
import java.awt.*;

public class ColorScribble extends Scribble {
      
      public void init() {
            super.init();
            Color foreground = getColorParameter("foreground");
            Color background = getColorParameter("background");
            if (foreground != null) this.setForeground(foreground);
            if (background != null) this.setBackground(background);
      }
      protected Color getColorParameter(String name) {
               String value = this.getParameter(name);
               int intvalue;
               try { intvalue = Integer.parseInt(value, 16);}
               catch (NumberFormatException e) {return null;}
               return new Color(intvalue);
      }

      public String[][] getParameterInfo() {
            String[][] info = {
                  {"foreground","hexadecimal color value","foreground color"},
                  {"background","hexadecimal color value","background color"}    
            };   
            return info;                      
      }

      public String getAppletInfo() {
            return "Scribble v. 0.02.Oritten by David Flanagan.";
      }
}
