/*     chatClient.java
 *     Ahmet E.Topcu
 *     CPS 606 Fall99
 */
         
import java.awt.*;
import java.io.*;
import java.net.*;
import java.awt.event.*;
import java.applet.Applet;
import java.util.StringTokenizer ;
public class chatClient extends Applet implements ActionListener {
        String hostName;
        String NickName;
        clientWorker mThread;
        boolean connectionFlag = false;
        DataInputStream SInput;
        DataOutputStream SOutput;
        chatGUI chatA;
        Socket s;

// make chatGUI and add actionlistener
        public void init() {
                chatA = new chatGUI();          
                add("Center",chatA.chatPanel);
                chatA.ButtonA.addActionListener( this );
                chatA.FieldA.addActionListener( this );
        }

// make clientWorker if there is client
// send "BYE" to server for disconnection
        
        public void actionPerformed ( ActionEvent e ) {

          try {
                if ( e.getSource() == chatA.ButtonA ) {
                  if(connectionFlag == false) {
                        NickName = chatA.NameA.getText();
                        if(NickName.length() == 0) {
                          chatA.TextAreaA.append("Please Type User Name");
                          return;
                        }
                        if(buildConnection() == false) return;
                        mThread = new clientWorker(SInput,chatA.TextAreaA,chatA.users);
                        connectionFlag = true;
                        chatA.ButtonA.setLabel("Click to Close");
			SOutput.writeUTF(""+NickName + "> <USERNAME> giving my user name\n");
		                  }
                  else {        
                        SOutput.writeUTF("BYE");
                        connectionFlag = false;
                        chatA.ButtonA.setLabel("Click to Connect");
                  }
                }
                else {
                  if(connectionFlag == false) return;
                  String line = new String(chatA.FieldA.getText());
                  chatA.FieldA.setText("");   
                  chatA.TextAreaA.append(NickName + ">" + line + "\n");
                  SOutput.writeUTF(NickName + ">" + line );
                }
            }
            catch ( IOException e_n ) {
                chatA.TextAreaA.append("error message : Network Error ");
          }
        }       
        
// build connection establish connection and get input stream and output
        boolean buildConnection (){
                Socket s;

                try {
                        s = new Socket(getCodeBase().getHost(), 9865);
                }
                catch(IOException e) {
                        chatA.TextAreaA.append("Can not open socket\n");
                        return false;
                }
                try {
                        SInput = new DataInputStream( s.getInputStream());
                        SOutput = new DataOutputStream( s.getOutputStream());
		
                }
                catch(IOException e) {
                        chatA.TextAreaA.append("Can not open stream\n");
                        return false;
                }
                return true;
        }
}

// clientWorker read stream from server and write it on own window
class clientWorker extends Thread {
      private DataInputStream InStream;
      private TextArea outT;
       List ulist;
      public clientWorker (DataInputStream in, TextArea out,List ul) {
        InStream = in;
        outT = out;
	ulist=ul;
        this.start();
      }

// run method is invoked by start() 
      public void run() {
            String data;
// with while(true), the readUTF is block for input
            try {
                  while(true) {
                        data = InStream.readUTF();
                        if (data == null) break;
			if (data.startsWith("USERS")) {
			    ulist.removeAll();
			    StringTokenizer  users   = new StringTokenizer(data,"+");
			    while (users.hasMoreTokens()) {
				String next=users.nextToken();
				ulist.addItem(next);
				 System.out.println(next);
			    }
			    System.out.println(data);
			}
			else 
			    outT.append( data + "\n");
			
                  }
            }
            catch (IOException e) {
            }
      }
}

// make GUI
class chatGUI {
      public TextArea  TextAreaA;
      public TextField FieldA, NameA;
      public Panel chatPanel;   
      public Button ButtonA;
      public List users;
      Label label1, label2, label3;      

      public chatGUI() {

            Panel PanelA,PanelB,PanelC,PanelD;

// Panel Layout for Chat Board
            chatPanel = new Panel();
            chatPanel.setLayout(new BorderLayout());
            PanelA = new Panel();
            PanelA.setLayout(new BorderLayout());
            Label label1 = new Label("Chat Window", Label.CENTER);
            label1.setFont(new Font("Courier", Font.BOLD, 18));
            label1.setForeground( Color.magenta);
            PanelA.add("North",label1);
            TextAreaA = new TextArea(14,45); 
            TextAreaA.setFont(new Font("Serif", Font.PLAIN, 18));
            label1.setForeground( Color.magenta );
            PanelA.add("Center",TextAreaA);
            chatPanel.add("North",PanelA);

            PanelB = new Panel();
            PanelB.setLayout(new BorderLayout());
            Label label2 = new Label("Input Line", Label.CENTER);
            label2.setFont(new Font("Ariel", Font.BOLD, 18));
            label2.setForeground( Color.green );
            PanelB.add("North",label2);
            FieldA = new TextField(45); 
            FieldA.setFont(new Font("Serif", Font.PLAIN, 18)); 
            PanelB.add("Center",FieldA);
            chatPanel.add("Center",PanelB);

            PanelC = new Panel();
            PanelC.setLayout(new BorderLayout());
            Label label3 = new Label("Login Name");
            label3.setFont(new Font("Ariel", Font.BOLD, 16));
            label3.setForeground( Color.gray); 
            PanelC.add("West",label3);
            NameA = new TextField(12);
            NameA.setFont(new Font("Serif", Font.PLAIN, 18));
            PanelC.add("Center",NameA);
            ButtonA = new Button("Click to Connect");
            ButtonA.setFont(new Font("Courier", Font.BOLD, 12));
            label1.setForeground( Color.green);
            PanelC.add("East",ButtonA);
            chatPanel.add("South",PanelC);
            users = new List();
            PanelA.add("East",users);
            users.addItem("user1..");
            users.addItem("user2..");
	    
	    
   }
}

