/*     chatServer.java
 *      Ahmet E. Topcu
 *      CPS 606 Fall 99 
 *      
 */
import java.awt.*;
import java.io.*;
import java.net.*;
import java.util.Vector ;
import java.util.Enumeration ;
public class chatServer {

// main method invoke chatMaster Thread
        public static void main(String[] args) {
                new chatMasterThread();
        }

}

// make a server socket and if client is binding, make makeServer
// and waiting another client
class chatMasterThread {
       
        streamManager streammng;
        ServerSocket servercsocket;
        Socket  socketA;
        Vector allusers;       
        public chatMasterThread(){
allusers=new Vector();
	    
                System.out.println("chat server master thread envoked");
                streammng = new streamManager();      

// Open server socket port
                try {
                        servercsocket = new ServerSocket( 9865);
                        System.out.println( "Socket successfully working" );
                }       
                catch ( IOException e ){
                System.out.println( "  Socket   error while connecting " );
                        return;
                }       

// accept() waiting the client and arrange the socket
                while( true ){
                        try {
                                socketA = servercsocket.accept();
                                System.out.println("New connection established");
                                chatServerWorker th = new chatServerWorker(streammng,socketA,this);
				
                        }
                        catch (IOException e){
                        }               
                }
        }
}

// streamManager maintain the stream array  
class streamManager {
        private DataOutputStream streamList[];
        private int NumberA[];
        private int cursor;
        private int GeneratorA; 

        public streamManager() {
                streamList = new DataOutputStream [30];
                NumberA = new int[30];
                cursor = 0;
                GeneratorA = 0;
        }

        public synchronized void messageSend(String msg, int cnum){
                if(cursor == 0) return;
                try {
                   for(int i = 0; i < cursor; i++ ){
                        if(NumberA[i] != cnum)
                                streamList[i].writeUTF(msg);             
                   }
                }
                catch ( IOException e ) {
                   System.out.println( "error message : Can not write to the network" );
                }
        }
        public synchronized int addStream(DataOutputStream ds){
                streamList[cursor] = ds;
                NumberA[cursor++] = GeneratorA;
                return(GeneratorA++);   
        }
// removeStream remove the stream from array by disconnection
        public synchronized void removeStream(int StreamNum){
                int     stop = -1;
                System.out.println("Remove Stream " + StreamNum);

                for(int i=0;i< cursor; i++) { 
                        System.out.print(NumberA[i]); 
                        System.out.print(" "); 
                }
                        
                System.out.println("");

                if(cursor == 0) return;
                else if(cursor == 1) {
                          cursor = 0;
                          return;
                }

                for(int i = 0 ; i < cursor -1 && stop == -1 ; i++ )
                        if( NumberA[i] == StreamNum ) {
                                stop = i;       
                        }

                if(stop != -1)
                  for(int i = stop ; i < cursor -1 ; i++ ){
                        System.out.println("Remove Stream -- " + i);
                        streamList[i] = streamList[i+1];
                        NumberA[i] = NumberA[i+1];
                  }
                cursor--;

                for(int i=0;i< cursor; i++) {
                  System.out.print(NumberA[i]) ; 
                  System.out.print(" "); 
                }
                System.out.println("");
        }
}

// chatServerWorker get stream from client   and deliever it to stream manager

class chatServerWorker extends Thread {
        streamManager  streamManagerA;
        int  streamNum;
        DataInputStream inStream;
        DataOutputStream outStream;
        chatMasterThread server;
        public chatServerWorker(streamManager streamA,Socket s,chatMasterThread  _server){
	        server=_server;
                streamManagerA = streamA;
		
                try {
                        System.out.println("New curior thread envoked");
                        inStream = new DataInputStream(s.getInputStream());
                        outStream = new DataOutputStream(s.getOutputStream());
					
                }
                catch (IOException e){
                        System.out.println("Stream error");
                        try {
                                s.close();
                        }
                        catch (IOException se) {
                                System.out.println("Socket Close error");
                        }
                }
                streamNum = streamManagerA.addStream(outStream);
                this.start();
        }

// if client send "BYE", then socket is disconnected
        public void run() {
                String rcbmsg;
		boolean inlist=false;
                System.out.println("Thread running");
                while(true){
                  try {
                        rcbmsg = inStream.readUTF();
                        if( rcbmsg.equals("BYE") ){
                          streamManagerA.removeStream(streamNum);
			  
                          return;
                        }
			if (!inlist) {
			    String name= rcbmsg.substring(0,rcbmsg.indexOf('>'));
			    System.out.println("User name is "+name);
			    server.allusers.addElement(name);
			    String allusers="";
			    
         for (Enumeration e = server.allusers.elements() ; e.hasMoreElements() ;) {
             //System.out.println(e.nextElement());
	     allusers+=e.nextElement()+"+";
	     
         }
	 
			    streamManagerA.messageSend("USERS+"+allusers,-347632);
			   inlist=true;
			} 
			else  streamManagerA.messageSend(rcbmsg,streamNum);
                        System.out.println("Receive" + streamNum + ":" + rcbmsg);
                        
                  }
                  catch (IOException e){
                  }     
                }
        }
}

