/**
     *      
     *   File: news2.java
     * 
     * This is final project networking for CPS606/Spring 1998.
     * This Java application will download email addresses from selected newsgroups 
     * and save them into a file.
     * The final project "Email Retrieval" for CPS606 was designed to retrieve 
     * email addresses from newsgroups for research or commercial purposes. The JAVA 
     * application, playing the role of a client, communicates with a news
     * server, e.g., "newstand.syr.edu" in the Syracuse University, via the Network 
     * News Transfer Protocol (NNTP). Further, this application may retrieve news 
     * contributors' email addresses from each post and store them into a file for 
     * future uses. 
     *
     * @version     1.0
     * @author      Hsiang Chen <hchen04@mailbox.syr.edu>
     * @since       JDK1.1
     */


import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.lang.Integer;
import java.net.*;

  
public class news2 extends Applet implements ActionListener { 
  Insets finsets; // variable for the height of the border
  int finsets2_top = 0;
  int finsets2_left = 0;
  private CheckboxGroup cbox_group_2 = new CheckboxGroup(); 
  private CheckboxGroup cbox_group_3 = new CheckboxGroup();
  public Label  forstatus;
  public Label  forresponse;
  public Label  status;
  public Label  response;
  static Button  button[];
  
  public Label  panel1;
  public Checkbox  alt;
  public Checkbox  comp;
  public Checkbox  bit;
  public Checkbox  misc;
  public Checkbox  rec;
  public Checkbox  soc;
  public Checkbox  syr;
  public Label  panel2;
  public Checkbox  _50;
  public Checkbox  _100;
  public Checkbox  _200;
  public Checkbox  _400;
  public Checkbox  _700;
  public Checkbox  _700_;
  public List  selectednewsgroups;
  public Button  connect;
  public Button  retrieve;
  public Button  store;
  public Button  exit;
  private Socket clientnews;
  private BufferedReader input;
  private DataOutputStream output;
  private LightThread light;
  public String line="";
  public int hit,hit1;
  public int totalgroups=0;
  public String groupitems[];
  public DataOutputStream myoutput;
  public Font font1;


  // main () for the this application; it create a frame and call init () and start ();
  public static void main(String args[])
  {
   Frame app=new Frame("News Email Address Retrieval");
   app.setSize(450,350);
   app.addWindowListener(new CloseWindowAndExit());
   news2 m=new news2();
   m.init(); 
   m.start();
   app.add(m, BorderLayout.CENTER);
   app.setVisible(true);
  }



  // The application is initialized. It will create interface and add functions to 
  //          that interface.
  public void init ()
  {
      setLayout(null);  // Set to null so I can arrange whatever I want.
      finsets = getInsets();  // In order to be plateform independent, I need to calculate finset;
      setBackground(new Color(128,0,0));
      forstatus = new Label("Status:");  // label for status;
      add(forstatus);

      forresponse = new Label("Response:"); // label for response;
      add(forresponse);

      // The displaying place for status. Don't know how to make it longer so here is what I did.
      status = new Label("Not connected.                                                                                        ");
      add(status);

      // The displaying place for response. 
      response = new Label("                                                                                                     ");
      add(response);
    
      // Adding 11 buttons so it would act like progressing bar
      button=new Button[11];
      button[1] = new Button("");
      add(button[1]);

      button[2] = new Button("");
      add(button[2]);

      button[3] = new Button("");
      add(button[3]);

      button[4]= new Button("");
      add(button[4]);

      button[5] = new Button("");
      add(button[5]);

      button[6] = new Button("");
      add(button[6]);

      button[7] = new Button("");
      add(button[7]);

      button[8] = new Button("");
      add(button[8]);

      button[9] = new Button("");
      add(button[9]);

      button[10] = new Button("");
      add(button[10]);

      panel1 = new Label("");
      add(panel1);


      //Adding different categories of newsgroups;
      alt = new Checkbox("alt.", cbox_group_2,false);
      alt.setForeground(new Color(255,255,255));

      add(alt);

      comp = new Checkbox("comp.", cbox_group_2,true);
      comp.setForeground(new Color(255,255,255));
      add(comp);

      bit = new Checkbox("bit.", cbox_group_2,false);
      bit.setForeground(new Color(255,255,255));
      add(bit);

      misc = new Checkbox("misc.", cbox_group_2,false);
      misc.setForeground(new Color(255,255,255));
      add(misc);

      rec = new Checkbox("rec.", cbox_group_2,false);
      rec.setForeground(new Color(255,255,255));
      add(rec);

      soc = new Checkbox("soc.", cbox_group_2,false);
      soc.setForeground(new Color(255,255,255));
      add(soc);

      syr = new Checkbox("syr.", cbox_group_2,false);
      syr.setForeground(new Color(255,255,255));
      add(syr);

      panel2 = new Label("");
      add(panel2);


      // adding different range of amount news in each news categories
      _50 = new Checkbox("<50", cbox_group_3,false);
      _50.setForeground(new Color(255,255,255));
      add(_50);

      _100 = new Checkbox("50-100", cbox_group_3,true);
      _100.setForeground(new Color(255,255,255));
      add(_100);

      _200 = new Checkbox("101-200", cbox_group_3,false);
      _200.setForeground(new Color(255,255,255));
      add(_200);

      _400 = new Checkbox("201-400", cbox_group_3,false);
      _400.setForeground(new Color(255,255,255));
      add(_400);

      _700 = new Checkbox("401-700", cbox_group_3,false);
      _700.setForeground(new Color(255,255,255));
      add(_700);

      _700_ = new Checkbox(">701", cbox_group_3,false);
      _700_.setForeground(new Color(255,255,255));
      add(_700_);


      // Create a list for displaying purpose
      selectednewsgroups = new List(10,true);
      add(selectednewsgroups);

      // Adding four functional buttons.
      connect = new Button("Connect");
      add(connect);

      retrieve = new Button("Retrieve");
      add(retrieve);

      store = new Button("Store");
      add(store);

      exit = new Button("Exit");
      add(exit);
     exit.addActionListener (this);
     connect.addActionListener (this);
     retrieve.addActionListener (this);
     store.addActionListener (this);


   // In order to have a better user interface, here I set font sizes, set bounds and colors
   //       for all of components in this applicaton


   forstatus.setBounds(10+finsets.left,18+finsets.top,33,13);
   forstatus.setFont(new Font("MSSansSerif",Font.PLAIN,12));
   forstatus.setSize(forstatus.getFontMetrics(forstatus.getFont()).stringWidth(forstatus.getText())+16,
   forstatus.getFontMetrics(forstatus.getFont()).getHeight()+3);
   forstatus.setBackground(new Color(128,0,0));
   forstatus.setForeground(new Color(255,255,255));

   forresponse.setBounds(10+finsets.left,34+finsets.top,35,13);
   forresponse.setFont(new Font("MSSansSerif",Font.PLAIN,12));
   forresponse.setBackground(new Color(128,0,0));
   forresponse.setForeground(new Color(255,255,255));
      
   forresponse.setSize(forresponse.getFontMetrics(forresponse.getFont()).stringWidth(forresponse.getText())+10,
   forresponse.getFontMetrics(forresponse.getFont()).getHeight()+3);
      status.setBounds(66+finsets.left,18+finsets.top,337,13);
      status.setBackground(new Color(128,0,0));
      status.setForeground(new Color(255,0,0));
      status.setFont(new Font("MSSansSerif",Font.PLAIN,12));
      
      status.setSize(status.getFontMetrics(status.getFont()).stringWidth(status.getText())+16,
      status.getFontMetrics(status.getFont()).getHeight()+3);
      if (status.getText().length() == 0)
      status.setVisible(false);  else
      status.setVisible(true);
      response.setBounds(85+finsets.left,34+finsets.top,341,13);
      response.setBackground(new Color(128,0,0));
      response.setForeground(new Color(255,0,0));
      response.setFont(new Font("MSSansSerif",Font.PLAIN,12));
      response.setSize(response.getFontMetrics(response.getFont()).stringWidth(response.getText())+16,
      response.getFontMetrics(response.getFont()).getHeight()+3);
      if (response.getText().length() == 0)
      response.setVisible(false);  else
      response.setVisible(true);

      button[1].setBackground(Color.green);
      button[1].setBounds(50+finsets.left,58+finsets.top,17,17);


      button[2].setBounds(70+finsets.left,58+finsets.top,17,17);


      button[3].setBounds(90+finsets.left,58+finsets.top,17,17);


      button[4].setBounds(110+finsets.left,58+finsets.top,17,17);


      button[5].setBounds(130+finsets.left,58+finsets.top,17,17);


      button[6].setBounds(150+finsets.left,58+finsets.top,17,17);


      button[7].setBounds(170+finsets.left,58+finsets.top,17,17);


      button[8].setBounds(190+finsets.left,58+finsets.top,17,17);


      button[9].setBounds(210+finsets.left,58+finsets.top,17,17);


      button[10].setBounds(230+finsets.left,58+finsets.top,17,17);



      panel1.setBounds(57+finsets.left,90+finsets.top,59,23);
      panel1.setBackground(new Color(3,0,0));
      panel1.setForeground(Color.black);
      panel1.setFont(new Font("MSSansSerif",Font.PLAIN,12));
      
      panel1.setSize(panel1.getFontMetrics(panel1.getFont()).stringWidth(panel1.getText())+16,
      panel1.getFontMetrics(panel1.getFont()).getHeight()+3);
      if (panel1.getText().length() == 0)
      panel1.setVisible(false);  else
      panel1.setVisible(true);
      alt.setBounds(58+finsets.left,98+finsets.top,70,17);
      alt.setFont(new Font("MSSansSerif",Font.PLAIN,12));
      
      alt.setSize(alt.getFontMetrics(alt.getFont()).stringWidth(alt.getLabel())+36,
      alt.getFontMetrics(alt.getFont()).getHeight()+3);
      alt.setVisible(true);
      comp.setBounds(58+finsets.left,117+finsets.top,70,17);
      comp.setFont(new Font("MSSansSerif",Font.PLAIN,12));
      
      comp.setSize(comp.getFontMetrics(comp.getFont()).stringWidth(comp.getLabel())+36,
      comp.getFontMetrics(comp.getFont()).getHeight()+3);
      comp.setVisible(true);
      bit.setBounds(58+finsets.left,135+finsets.top,70,17);
      bit.setFont(new Font("MSSansSerif",Font.PLAIN,12));
      
      bit.setSize(bit.getFontMetrics(bit.getFont()).stringWidth(bit.getLabel())+36,
      bit.getFontMetrics(bit.getFont()).getHeight()+3);
      bit.setVisible(true);
      misc.setBounds(58+finsets.left,154+finsets.top,70,17);
      misc.setFont(new Font("MSSansSerif",Font.PLAIN,12));
      
      misc.setSize(misc.getFontMetrics(misc.getFont()).stringWidth(misc.getLabel())+36,
      misc.getFontMetrics(misc.getFont()).getHeight()+3);
      misc.setVisible(true);
      rec.setBounds(58+finsets.left,173+finsets.top,70,17);
      rec.setFont(new Font("MSSansSerif",Font.PLAIN,12));
      
      rec.setSize(rec.getFontMetrics(rec.getFont()).stringWidth(rec.getLabel())+36,
      rec.getFontMetrics(rec.getFont()).getHeight()+3);
      rec.setVisible(true);
      soc.setBounds(58+finsets.left,191+finsets.top,70,17);
      soc.setFont(new Font("MSSansSerif",Font.PLAIN,12));
      
      soc.setSize(soc.getFontMetrics(soc.getFont()).stringWidth(soc.getLabel())+36,
      soc.getFontMetrics(soc.getFont()).getHeight()+3);
      soc.setVisible(true);
      syr.setBounds(58+finsets.left,210+finsets.top,70,17);
      syr.setFont(new Font("MSSansSerif",Font.PLAIN,12));
      
      syr.setSize(syr.getFontMetrics(syr.getFont()).stringWidth(syr.getLabel())+36,
      syr.getFontMetrics(syr.getFont()).getHeight()+3);
      syr.setVisible(true);
      panel2.setBounds(153+finsets.left,90+finsets.top,59,23);
      panel2.setBackground(new Color(3,0,0));
      panel2.setForeground(Color.black);
      panel2.setFont(new Font("MSSansSerif",Font.PLAIN,12));
      
      panel2.setSize(panel2.getFontMetrics(panel2.getFont()).stringWidth(panel2.getText())+16,
      panel2.getFontMetrics(panel2.getFont()).getHeight()+3);
      if (panel2.getText().length() == 0)
      panel2.setVisible(false);  else
      panel2.setVisible(true);
      _50.setBounds(154+finsets.left,106+finsets.top,70,17);
      _50.setFont(new Font("MSSansSerif",Font.PLAIN,10));
      
      _50.setSize(_50.getFontMetrics(_50.getFont()).stringWidth(_50.getLabel())+36,
      _50.getFontMetrics(_50.getFont()).getHeight()+3);

      _100.setBounds(154+finsets.left,126+finsets.top,70,17);
      _100.setFont(new Font("MSSansSerif",Font.PLAIN,10));
      
      _100.setSize(_100.getFontMetrics(_100.getFont()).stringWidth(_100.getLabel())+36,
      _100.getFontMetrics(_100.getFont()).getHeight()+3);
      _100.setVisible(true);
      _200.setBounds(154+finsets.left,146+finsets.top,70,17);
      _200.setFont(new Font("MSSansSerif",Font.PLAIN,10));
      
      _200.setSize(_200.getFontMetrics(_200.getFont()).stringWidth(_200.getLabel())+36,
      _200.getFontMetrics(_200.getFont()).getHeight()+3);

      _400.setBounds(154+finsets.left,167+finsets.top,70,17);
      _400.setFont(new Font("MSSansSerif",Font.PLAIN,10));
      
      _400.setSize(_400.getFontMetrics(_400.getFont()).stringWidth(_400.getLabel())+36,
      _400.getFontMetrics(_400.getFont()).getHeight()+3);

      _700.setBounds(154+finsets.left,187+finsets.top,70,17);
      _700.setFont(new Font("MSSansSerif",Font.PLAIN,10));
      
      _700.setSize(_700.getFontMetrics(_700.getFont()).stringWidth(_700.getLabel())+36,
      _700.getFontMetrics(_700.getFont()).getHeight()+3);

      _700_.setBounds(154+finsets.left,207+finsets.top,70,17);
      _700_.setFont(new Font("MSSansSerif",Font.PLAIN,10));
      
      _700_.setSize(_700_.getFontMetrics(_700_.getFont()).stringWidth(_700_.getLabel())+36,
      _700_.getFontMetrics(_700_.getFont()).getHeight()+3);

      selectednewsgroups.setBounds(242+finsets.left,90+finsets.top,180,145);
      selectednewsgroups.setFont(new Font("MSSansSerif",Font.PLAIN,11));
      selectednewsgroups.setBackground(new Color(0,128,128));
      selectednewsgroups.setForeground(new Color(255,255,255));
      connect.setBounds(26+finsets.left,250+finsets.top,75,25);
      connect.setFont(new Font("MSSansSerif",Font.PLAIN,12));
      connect.setEnabled(true);

      retrieve.setBounds(127+finsets.left,250+finsets.top,75,25);
      retrieve.setFont(new Font("MSSansSerif",Font.PLAIN,12));
      retrieve.setEnabled(false);

      store.setBounds(229+finsets.left,250+finsets.top,75,25);
      store.setFont(new Font("MSSansSerif",Font.PLAIN,12));
      store.setEnabled(false);

      exit.setBounds(330+finsets.left,250+finsets.top,75,25);
      exit.setFont(new Font("MSSansSerif",Font.PLAIN,12));
      exit.setEnabled(false);

  }


  // Here is what happens in this application

  // determine which button is pressed and to call a specific method, accordingly.
  public void actionPerformed (ActionEvent e)
  {
   if (e.getSource()==connect)
     doconnection () ;
   else if (e.getSource()==retrieve)
     doretrieve ();
   else if (e.getSource()==store)
     dostore ();
   else if (e.getSource()==exit)
     doexit ();
  }
   

  // Connect button is clicked
  public void doconnection ()
  {  
     // calling a thread to display the running progressive bar
     light=new LightThread();
     light.start();

     
     String rdata="";
  
   // display the current status
   try {status.setText("Connecting to newstand.syr.edu ... ");

   // create a new socket and make link to SU's news server (newstand.syr.edu) at port 119
       clientnews=new Socket ("newstand.syr.edu", 119);

   // create input and output stream;
       output=new DataOutputStream(clientnews.getOutputStream());
       input=new BufferedReader (new InputStreamReader
             (clientnews.getInputStream()));
       }
   catch (IOException e) { e.printStackTrace();}       


   // After successfual connection, the news server will send back something like this:
   //  "200 newstand.syr.edu InterNetNews NNRP server INN 1.4unoff3 17-Oct-95 ready (posting ok)."
   // input stream needs to catch this reply          

   try{ line=input.readLine();} catch (IOException e) { e.printStackTrace();} 
   if (line!=null)
      {
        // display the caught reply in the response label
        response.setText(line);

        // check if the caught reply starts with "200". 
        if (line.startsWith("200"))
        {   
            // Yes, 200. So display the successful result in a label.
            status.setText("News server connected.");

            // No, not 200. So something wrong.
        } else {status.setText("Error in connecting with News server.");}

      } else {status.setText("Error in connecting with News server.");}

   // Afer successful connection, now user can proceed to another step. 
   light.stop();   
   retrieve.setEnabled(true); 
   connect.setEnabled(false);
  }

  // When a user can click on "retrieve button", the connection is already successful.
  public void doretrieve () 
  { String whichgroup="";
    String postnumber="";

   //Check which news category the user selected.
   if (cbox_group_2.getSelectedCheckbox()==alt) 
    {whichgroup="alt";} else 
   if (cbox_group_2.getSelectedCheckbox()==comp) 
    {whichgroup="comp";} else 
   if (cbox_group_2.getSelectedCheckbox()==bit) 
    {whichgroup="bit";} else 
   if (cbox_group_2.getSelectedCheckbox()==misc) 
    {whichgroup="misc";} else 
   if (cbox_group_2.getSelectedCheckbox()==rec) 
    {whichgroup="rec";} else 
   if (cbox_group_2.getSelectedCheckbox()==soc) 
    {whichgroup="soc";} else 
   if (cbox_group_2.getSelectedCheckbox()==syr) 
    {whichgroup="syr";}

   // Check which number of posts the user selected.
   if (cbox_group_3.getSelectedCheckbox()==_50) 
    {postnumber="less than 50 posts";hit=50;hit1=10;} else 
   if (cbox_group_3.getSelectedCheckbox()==_100) 
    {postnumber="between 51 and 100 posts";hit1=51;hit=100;} else 
   if (cbox_group_3.getSelectedCheckbox()==_200) 
    {postnumber="between 101 and 200 posts";hit1=101;hit=200;} else 
   if (cbox_group_3.getSelectedCheckbox()==_400) 
    {postnumber="between 201 to 400 posts";hit1=201;hit=400;} else 
   if (cbox_group_3.getSelectedCheckbox()==_700) 
    {postnumber="between 401 and 700 posts";hit1=4010;hit=700;} else 
   if (cbox_group_3.getSelectedCheckbox()==_700_) 
    {postnumber="more than 700 posts";hit1=701;hit=1000;} 


   // run a thread to display the progressive bar 
   light=new LightThread();
   light.start();

   // send a NNTP command "LIST" to list all available newsgroups in this news server

   try {output.writeBytes("LIST\r\n");} catch (IOException e) { e.printStackTrace();}

   // After sending out "LIST", the server's response is like this:
   //alt.video.dvd 0000030121 0000025878 y
   //alt.video.dvd.tech 0000000928 0000000753 y
   //alt.video.dvd.software 0000000760 0000000624 y  
   // .....
   // .....

   
   // Now the input stream needs to catch all of them and parse it

   try{ line=input.readLine();} catch (IOException e) { e.printStackTrace();} 
   if (line!=null)
     {
       response.setText(line);
       try {
       if (line.startsWith("215"))
       { while ((line=input.readLine())!=null)
          {
           if (line.startsWith(".")) break;  
           // This is a loop for readLine(). So if it reaches the last newsgroup,
           // the newsserver will send out a line with "." as the first and
           // the only character in that line. If this is the case, then break.
           // Otherwise, the loop continues.
  
           // determine if the listed newsgroup is the ones the user needed
           if (line.startsWith(whichgroup+"."))
            {
            // Yes, this newsgroup is the user wants so process and do some parsing
            // it in the method "processline()"
             processline();
             status.setText("Desired newsgroups found and are listing now....");
             
             }

          }
       } else {status.setText("Error in listing Newsgroups."); }
         }
        catch (IOException e) { e.printStackTrace();}
     }
   light.stop();
   retrieve.setEnabled(false);
   store.setEnabled(true);

  }


  public void dostore () 
   {String myline="";
    int total=0;
    light=new LightThread();
    light.start();

    // create a file for writin purpose.

    try {
       myoutput=new DataOutputStream(
       new FileOutputStream("news.dat"));
        }
    catch (IOException e) {}

    // get the selected newsgroups from LIST "selectednewsgroups"

    groupitems=selectednewsgroups.getSelectedItems();

    // Now process each newsgroup
    for (int w=0; w<groupitems.length; w++)
      { 
        // get first or first+w newsgroups in LIST

        String chosengroups=groupitems[w];

        // get the name of that line and discard the rest of the line

        int i=chosengroups.indexOf((int) ' ',1);

       // Now the chosengroups would be the exact name of the newsgroup
        chosengroups=chosengroups.substring(0,i);

        response.setText("Retrieving from "+chosengroups);

       // Now sending out NNTP command "GROUP newsgroups_name" to ask the news server
       // move its pointer to that newsgroup

        try {output.writeBytes("GROUP "+chosengroups+"\r\n");
        } catch (IOException e) { e.printStackTrace();}

      // Get the reply from server
        try{  myline=input.readLine();
        } catch (IOException e) { e.printStackTrace();}


     // If the server replies with "421", that means no more articles in that newsgroup ...

        try{
         while (!(myline.startsWith("421")))
         { 

    // Otherwise, there are some articles in that selected newsgroup.
    // If this is the case, then sending out another NNTP command "HEAD",
    // asking the server to list the heading of that article

          try{   output.writeBytes("HEAD\r\n");} catch (IOException e) { e.printStackTrace();}

   // Now the server is listing the heading of the current article in the seleced newsgroup
   // Prepare to catch them. If it is not starts with "." in that line, then we have not reach
   // the end line of that heading.

         try { while (((myline=input.readLine())!=null)&& (!(myline.startsWith("."))))  
                { 

   // I care only the line starting with "From: " because I need their email address.
   // So I want to see if I am in that line ...

                  if (myline.startsWith("From: "))
                   {  
                   // Now I am in that line starting with "From: ", so write it down
                   // to the file.

                      total++; 
                      status.setText("Total Records written: "+total);
                      myoutput.writeUTF(myline+"\r\n");
                   } 

                 // If it reach the end of heading, break this loop.
                 if (myline.startsWith(".")) break;
                } 
           }catch (Exception e) { System.out.println(myline);};

          // Now the heading of the current article is done. 
          // So issue another NNTP command "NEXT" to proceed.
          // The server will move its pointer to the next article.

            try{ output.writeBytes("NEXT\r\n");} catch (Exception e) {}; 
            try { myline=input.readLine();} catch (Exception e){};
         } 
        output.writeBytes("NEXT\r\n"); myline=input.readLine();
     } catch (Exception e) {}
    }
    light.stop();
    try {myoutput.close(); } catch (IOException io) {};
    store.setEnabled(false);
    exit.setEnabled(true);

   }

  public void doexit () 
  {
    // Now the user clicks on the "exit" button. So exit it.

    // Sending out a NNTP command "QUIT" to tell the server we are quitting.    

    try{ output.writeBytes("QUIT\r\n");} catch (Exception e) {}; 
    try{      line=input.readLine();} catch (Exception e) {};

    // If the serve says "205", then we can exit now.
    status.setText(line);
    if (line.startsWith("205"))System.exit(0);
  };

 
  // This is the method to parse the line from server

  public void processline() 
  {String laststring,start,end;
   int amount;

   // Get the index number of the first double space

   int i=line.indexOf((int) ' ',1);

   // Get the index number of the second double space

   int k=line.indexOf((int) ' ',i+2);

   // laststring will contain only the newsgroup name

   laststring=line.substring(0,i);

   // Now end will contains the last number of posts in the newsgroup

   end=line.substring(i+2,k);

   // Now start will contains the last number of posts in the newsgroup

   start=line.substring(k+1,line.length()-2);  

  // to see if both them are zero.

   while ((start.charAt(0)=='0')&&(start.length()>1)) {
          String mystart=start.substring(1,start.length());
          start=mystart;}
  while ((end.charAt(0)=='0') && (end.length()>1)) {
          String myend=end.substring(1,end.length());
          end=myend;}

  // amount will have the total available number of posts in that newsgroup

   amount=(Integer.valueOf(end).intValue())-(Integer.valueOf(start).intValue());

  // display to name and start nubmer and total number of posts in that newsgroup
  // only if they are in the range of user' preference.

   if ((amount>hit1) &&(amount<hit)) 
     {
       selectednewsgroups.add(laststring+" "+start+" "+amount+"\n"); 
       totalgroups++;  
     }
  }

}


// This is a thread which displaying simulated progressive bar.

class LightThread extends Thread {
  int sleepTime, buttonSequence;
  public LightThread ()
  {
   sleepTime=100;
   buttonSequence=1;
  }

  public void run ()
  { int i;
    while (true) {
     for ( i=1; i<11; i++)
     {
      news2.button[i].setBackground(Color.green);
      try {
             Thread.sleep(sleepTime);
          } catch (InterruptedException exception) {}
      if (i==10) 
       { for (i=1; i<11; i++) {news2.button[i].setBackground(Color.white);};}
      }

     
    }
  }
}
